//
// $Id$
//

#import <AppKit/AppKit.h>

@class FIWindowController;

@interface Brain : NSObject
{
    FIWindowController *windowController;
    NSDocument *document;
    NSTimer *autoSaveTimer;
}

+ (void) initialize;

- init;
- (void) dealloc;

- (void) applicationDidFinishLaunching:(NSNotification *)aNotification;
- (void) applicationWillTerminate:(NSNotification *)aNotification;
//- (BOOL) applicationShouldTerminate:(NSApplication *)sender;

- (void) workspaceNotification:(NSNotification *)aNotification;

- (void) showInfoPanel:sender;
- (void) showPreferencePanel:sender;
- (void) showActiveApplications:sender;
- (void) showInspectorPanel:sender;
- (void) showFindPanel:sender;

//======================================================================
//" Services
//======================================================================

- (void) submitToFiendDock:(NSPasteboard *)pasteboard userData:(NSData *)data error:(NSString **)error;

//======================================================================
//" Dock paths
//======================================================================

- (NSString *) dockFilename;
- (NSString *) dockPath;

//======================================================================
//" NSApplication delegate
//======================================================================

- (BOOL) applicationShouldOpenUntitledFile:(NSApplication *)sender;

//======================================================================
//" NSWorkspace workaround (for RDR1, RDR2)
//======================================================================

- (void) forwardWorkspaceNotification:(NSNotification *)aNotification;

//======================================================================
//" Menu Actions
//======================================================================

- (void) addWorkspaceIcon:sender;
- (void) rotateLevel:sender;
- (void) addLevel:sender;
- (void) clearLevel:sender;
- (void) deleteLevel:sender;

- (void) nextLevel:sender;
- (void) previousLevel:sender;

- (void) toggleDockVisible:sender;
- (void) toggleDockSunken:sender;
- (void) toggleDockLocked:sender;
- (void) updateIcons:sender;

- (void) cut:sender;
- (void) copy:sender;
- (void) paste:sender;
- (void) clear:sender;
- (void) selectAll:sender;

//======================================================================
//" Other
//======================================================================

- (NSUndoManager *) undoManager;

- (void) undo:sender;
- (void) redo:sender;

- (BOOL) validateMenuItem:(NSMenuItem *)menuItem;

//======================================================================
//" Auto save timer
//======================================================================

- (void) startAutoSaveTimer;
- (void) stopAutoSaveTimer;
- (void) fireAutoSaveTimer:(NSTimer *)timer;

- (void) terminate:sender;

- (void) findNext:sender;
- (void) findPrevious:sender;

- (void) _moveDocksToNewFilenames;

@end
