//
// $Id$
//

#import <AppKit/AppKit.h>
#import <OmniFoundation/OmniFoundation.h>

@interface FIAppInfo : OFObject
{
    int ownerContext;
    int tokenWindowNumber;
    int pid;
    NSString *shortName;

    int uid;
    NSString *userName;
}

+ (NSDictionary *) activeAppInfo;

+ appInfoWithOwnerContext:(int)ownerContext;

- initWithOwnerContext:(int)anOwnerContext
     tokenWindowNumber:(int)aWindowNumber
                   pid:(int)aPid
             shortName:(NSString *)aShortName
                   uid:(int)aUid;
- (void) dealloc;

- (int) ownerContext;
- (int) pid;
- (int) tokenWindowNumber;
- (NSString *) shortName;

- (int) uid;
- (NSString *) userName;

- (void) activateApplicationAndHideOthers:(BOOL)hideOthers;

- (void) hideTokenWindow;
- (void) unhideTokenWindow;

//======================================================================
//" Debugging
//======================================================================

- (NSMutableDictionary *) debugDictionary;

@end
