//
// $Id$
//

#import <AppKit/AppKit.h>

#import "FIEmptyTileView.h"
#import "FIDockViewDelegateProtocol.h"
#import "FIDockViewDatasourceProtocol.h"

@interface FIDockView : FIEmptyTileView
{
    NSButton *previousLevelButton;
    NSButton *activateButton;
    NSButton *nextLevelButton;

    NSTextFieldCell *dockNameCell;
    NSTextFieldCell *dockNumberCell;

    NSBezierPath *lockedPath;

    id <NSObject, FIDockViewDatasource> nonretainedDatasource;
    id <NSObject, FIDockViewDelegate> nonretainedDelegate;
}

+ (void) initialize;
+ (void) adjustImageSizes;

- initWithFrame:(NSRect)frameRect;

- (void) drawRect:(NSRect)rect;

- (void) mouseDown:(NSEvent *)theEvent;
- (void) mouseUp:(NSEvent *)theEvent;

//======================================================================
//" Attributes
//======================================================================

- datasource;
- (void) setDatasource:newDatasource;

- delegate;
- (void) setDelegate:newDelegate;

//======================================================================
//" Covers for datasource methods.
//======================================================================

- (BOOL) isDockVisible;
- (BOOL) isDockLocked;

//======================================================================
//" Button actions
//======================================================================

- (void) buttonAction:sender;

//======================================================================
//" NSDraggingDestination
//======================================================================

- (BOOL) prepareForDragOperation:(id <NSDraggingInfo>)sender;
- (BOOL) performDragOperation:(id <NSDraggingInfo>)sender;
- (void) concludeDragOperation:(id <NSDraggingInfo>)sender;

- (unsigned int) draggingEntered:(id <NSDraggingInfo>)sender;
- (unsigned int) draggingUpdated:(id <NSDraggingInfo>)sender;
- (void) draggingExited:(id <NSDraggingInfo>)sender;

//======================================================================
//" Handling preference notifications
//======================================================================

- (void) styleDidChange:(NSNotification *)aNotification;

@end
