#import "Fiend.h"

RCS_ID ("$Id$");

#import "FIDocument.h"

#import "FIDock.h"
#import "FIWindowController.h"

@implementation FIDocument

- init
{
    if ([super init] == nil)
        return nil;

    model = [[FIDock allocWithZone:[self zone]] init];
    [model setDocument:self];

    return self;
}

//----------------------------------------------------------------------

- (void) dealloc
{
    SNRelease (model);
    [super dealloc];
}

//======================================================================
// NSDocument stuff
//======================================================================

- (void) makeWindowControllers
{
    FIWindowController *windowController;

    windowController = [[FIWindowController allocWithZone:[self zone]] init];
    [self addWindowController:windowController];
    [windowController release];
}

//----------------------------------------------------------------------

- windowController
{
    NSArray *controllers;
    id controller = nil;

    controllers = [self windowControllers];
    if ([controllers count] > 0)
        controller = [controllers objectAtIndex:0];

    return controller;
}

//----------------------------------------------------------------------

- (NSData *) dataRepresentationOfType:(NSString *)aType
{
    NSDictionary *dockPropertyList;
    NSString *str;
    
    dockPropertyList = [model propertyListForDock];
    str = [dockPropertyList description];

    return [str dataUsingEncoding:NSASCIIStringEncoding];;
}

//----------------------------------------------------------------------

- (BOOL) loadDataRepresentation:(NSData *)data ofType:(NSString *)aType
{
    NSString *string;
    NSDictionary *savedDock;

    string = [[NSString allocWithZone:[self zone]] initWithData:data encoding:NSASCIIStringEncoding];
    savedDock = [string propertyList];
    [string release];
    if (savedDock != nil)
    {
        FIDock *newDock;
        newDock = [[FIDock allocWithZone:[self zone]] init];
        [newDock loadDockFromPropertyList:savedDock];
        [self setModel:newDock];
        [newDock release];
    }
    return YES;
}

//----------------------------------------------------------------------

- (BOOL) keepBackupFile
{
    return YES;
}

//======================================================================
// Other
//======================================================================

- (FIDock *) model
{
    return model;
}

//----------------------------------------------------------------------

- (void) setModel:(FIDock *)newModel
{
    if (newModel == model)
        return;

    SNRelease (model)
        model = [newModel retain];
    [[self undoManager] removeAllActions];
    [model setDocument:self];
}

@end
