#import "Fiend.h"

RCS_ID ("$Id$");

#import "FIEmptyTileView.h"

@implementation FIEmptyTileView

//======================================================================
//" The bounds size is always 64 by 64, so drawing adornments will be
//" scaled when necessary.  However, images need to be manually scaled
//" since compositing doesn't take into account the view coordinate
//" system...
//======================================================================

static NSImage *_blankTileImage = nil;

+ (void) initialize
{
    static BOOL initialized = NO;
    float tileWidth;
    NSSize tileSize;

    [super initialize];
    if (initialized == YES)
        return;
    initialized = YES;
    
    _blankTileImage = [[NSImage imageNamed:@"BlankTile" inBundleForClass:self] retain];
    OBPOSTCONDITION (_blankTileImage != nil);
    [_blankTileImage setScalesWhenResized:YES];

    tileWidth = [[OFUserDefaults sharedUserDefaults] floatForKey:DK_TileSize];
    tileSize = NSMakeSize (tileWidth, tileWidth);
    [_blankTileImage setSize:tileSize];

    // XXX: And it should be resized whenever the default changes on the fly.
}

//----------------------------------------------------------------------

- initWithFrame:(NSRect)frameRect
{
    if ([super initWithFrame:frameRect] == nil)
        return nil;

    return self;
}

//----------------------------------------------------------------------

- (void) drawRect:(NSRect)rect
{
    [super drawRect:rect];
#if 0    
    {
        NSRect boundsRect = [self bounds];
        NSSize imageSize = [_blankTileImage size];
        //SNLogRect (boundsRect);
        //SNLogSize (imageSize);
    }
#endif
    if (_blankTileImage != nil)
        [_blankTileImage compositeToPoint:NSZeroPoint operation:NSCompositeSourceOver];
}

@end
