#import "Fiend.h"

RCS_ID ("$Id$");

#import "FISoundManager.h"
#import "FIDock.h"

@implementation FISoundManager

+ sharedSoundManager
{
    static FISoundManager *instance = nil;

    if (instance == nil)
        instance = [[FISoundManager alloc] init];

    return instance;
}

//----------------------------------------------------------------------

- init
{
    if ([super init] == nil)
        return nil;

    defaults = [OFUserDefaults sharedUserDefaults];
    fiendSound = [[NSSound soundNamed:@"Destroy"] retain];
    destroySound = [[NSSound soundNamed:@"Fiend"] retain];

    return self;
}

//----------------------------------------------------------------------

- (void) dealloc
{
    SNRelease (defaults);
    SNRelease (fiendSound);
    SNRelease (destroySound);

    [super dealloc];
}

//----------------------------------------------------------------------

- (BOOL) shouldPlaySound
{
    return [defaults boolForKey:DK_UseSounds];
}

//----------------------------------------------------------------------

- (void) didAddTilesForDock:(FIDock *)dock
{
    DSTART;
    [[[dock undoManager] prepareWithInvocationTarget:self] didRemoveTilesForDock:dock];
    if ([self shouldPlaySound] == YES)
    {
      //NSLog (@"playing add sound... %@", [dock undoManager]);
        [fiendSound play];
    }
    DEND;
}

//----------------------------------------------------------------------

- (void) didRemoveTilesForDock:(FIDock *)dock
{
    DSTART;
    [[[dock undoManager] prepareWithInvocationTarget:self] didAddTilesForDock:dock];
    if ([self shouldPlaySound] == YES)
    {
      //NSLog (@"playing destroy sound... %@", [dock undoManager]);
        [destroySound play];
    }
    DEND;
}

@end
