//
// $Id$
//

#import <AppKit/AppKit.h>
#import "FIEmptyTileView.h"
#import "FITileViewDelegateProtocol.h"
#import "FITileViewDatasourceProtocol.h"

@interface FITileView : FIEmptyTileView
{
    NSImage *image;
    NSPoint compositePoint;

    id <NSObject, FITileViewDelegate> nonretainedDelegate;
    id <NSObject, FITileViewDatasource> nonretainedDatasource;
}

+ (void) initialize;

- initWithFrame:(NSRect)frameRect;
- (void) dealloc;

- (void) drawRect:(NSRect)rect;
- (void) mouseDown:(NSEvent *)theEvent;

- (NSImage *) image;
- (void) setImage:(NSImage *)newImage;
- (void) _calculateCompositePoint;

- datasource;
- (void) setDatasource:newDatasource;

- delegate;
- (void) setDelegate:newDelegate;

//======================================================================
//" Covers for the datasource methods
//======================================================================

- (NSImage *) animationImage;
- (BOOL) shouldAutoLaunch;
- (BOOL) shouldAnimate;
- (BOOL) isPersistent;
- (BOOL) isRunning;
- (BOOL) isGhosted;
- (BOOL) isSelected;

//======================================================================
//" NSDraggingDestination
//======================================================================

- (BOOL) prepareForDragOperation:(id <NSDraggingInfo>)sender;
- (BOOL) performDragOperation:(id <NSDraggingInfo>)sender;
- (void) concludeDragOperation:(id <NSDraggingInfo>)sender;

- (unsigned int) draggingEntered:(id <NSDraggingInfo>)sender;
- (unsigned int) draggingUpdated:(id <NSDraggingInfo>)sender;
- (void) draggingExited:(id <NSDraggingInfo>)sender;

//======================================================================
//" Other
//======================================================================

- (void) styleDidChange:(NSNotification *)aNotification;

@end
