#import "Fiend.h"

RCS_ID ("$Id$");

#import "FITileWindow.h"

@interface NSWindow (hidden)
- _tempHide:(BOOL)hideFlag relWin:(int)x;
- (void) _setAvoidsActivation:(BOOL)flag;
- (BOOL) _canHide;
@end


@implementation FITileWindow

- init
{
    NSRect windowFrame;
    float tileSize;

    tileSize = [[OFUserDefaults sharedUserDefaults] floatForKey:DK_TileSize];
    
    windowFrame = NSMakeRect (0, 0, tileSize, tileSize);
    //SNLogRect (windowFrame);

    if ([super initWithContentRect:windowFrame
               styleMask:NSBorderlessWindowMask
               backing:NSBackingStoreBuffered
               defer:NO] == nil)
    {
        return nil;
    }

    [self _setAvoidsActivation:YES];

    return self;
}

//----------------------------------------------------------------------
//" This stops the tile windows from being hidden.  (But not perfectly.)
//----------------------------------------------------------------------
#if 0
- _tempHide:(BOOL)hideFlag relWin:(int)x
{
#if 0
    id r;
    NSLog (@"hideFlag: %@, x: %d", NSStringFromBool (hideFlag), x);
    //r = [super _tempHide:hideFlag relWin:x];
    r = [super _tempHide:NO relWin:x];
    SNLog (r);
    return r;

    //return [super _tempHide:hideFlag relWin:x];
    //return [super _tempHide:NO relWin:x];
#endif
#if 1
    if (hideFlag == NO)
        [super _tempHide:hideFlag relWin:x];
    
    return self;
#endif
}
#endif

//----------------------------------------------------------------------
//" This will be a much better way of preventing the tiles from being
//" hidden.  The previous method had weird problems with windows after
//" the application was reactivated...  i.e. hide, activate, inspector
//" window not key until switching back and forth again..
//----------------------------------------------------------------------

- (BOOL) _canHide
{
    return NO;
#if 0
    BOOL _canHide;
    DSTART;
    _canHide = [super _canHide];
    SNLogBool (_canHide);
    DEND;
    _canHide = NO;
    return _canHide;
#endif
}

@end
