#import <OmniBase/OmniBase.h>

RCS_ID ("$Id$");

#import "FiendTypes.h"

FiendTileCorner FITileCornerFromString (NSString *str)
{
    FiendTileCorner corner;

    if ([str isEqualToString:@"SW"])
        corner = SouthWestCorner;
    else if ([str isEqualToString:@"NW"])
        corner = NorthWestCorner;
    else if ([str isEqualToString:@"SE"])
        corner = SouthEastCorner;
    else
        corner = NorthEastCorner;

    return corner;
}

//----------------------------------------------------------------------

NSString *NSStringFromFiendTileCorner (FiendTileCorner corner)
{
    NSString *str;

    switch (corner)
    {
      case SouthWestCorner:
          str = @"SW";
          break;
          
      case NorthWestCorner:
          str = @"NW";
          break;
          
      case SouthEastCorner:
          str = @"SE";
          break;
          
      case NorthEastCorner:
      default:
          str = @"NE";
          break;
    }

    return str;
}

//----------------------------------------------------------------------

NSString *NSStringFromDockLocation (DockLocation location)
{
    return [NSString stringWithFormat:@"%d, %d", location.x, location.y];
}

//----------------------------------------------------------------------

NSString *NSStringFromTimeUnit (TimeUnit timeUnit)
{
    NSString *str = @"<unknown>";

    if (timeUnit == tuNone)
        str = @"none";
    else if (timeUnit == tuSeconds)
        str = @"seconds";
    else if (timeUnit == tuMinutes)
        str = @"minutes";

    return str;
}                                

//----------------------------------------------------------------------

TimeUnit timeUnitFromString (NSString *str)
{
    TimeUnit timeUnit = tuNone;

    if ([str isEqual:@"none"] == YES)
        timeUnit = tuNone;
    else if ([str isEqual:@"seconds"] == YES)
        timeUnit = tuSeconds;
    else if ([str isEqual:@"minutes"] == YES)
        timeUnit = tuMinutes;

    return timeUnit;
}

//----------------------------------------------------------------------

float secondsInTimeInterval (TimeInterval timeInterval)
{
    float seconds = 0;

    if (timeInterval.timeUnit == tuSeconds)
        seconds = timeInterval.timeValue;
    else if (timeInterval.timeUnit == tuMinutes)
        seconds = timeInterval.timeValue * 60;

    return seconds;
}

//----------------------------------------------------------------------

NSString *NSStringFromTimeInterval (TimeInterval timeInterval)
{
    return [NSString stringWithFormat:@"%.2f %@", timeInterval.timeValue, NSStringFromTimeUnit (timeInterval.timeUnit)];
}
