#import "Fiend.h"

RCS_ID ("$Id$");

#import "FIDockInspector.h"

#import "FIDock.h"
#import "FILevel.h"
#import "FITile.h"
#import "FIWindowController.h"
#import "FILevelFormatter.h"
#import "FIDocument.h"

@implementation FIDockInspector

+ sharedDockInspector
{
    static FIDockInspector *instance = nil;

    if (instance == nil)
        instance = [[FIDockInspector alloc] init];

    return instance;
}

//----------------------------------------------------------------------

- init
{
    DSTART;
    
    if ([super initWithWindowNibName:@"DockInspector"] == nil)
        return nil;

    DEND;

    return self;
}

//----------------------------------------------------------------------

- (void) dealloc
{
    [super dealloc];
}

//----------------------------------------------------------------------

- (void) windowDidLoad
{
    //OAOutlineTextFormatter *textFormatter;
    FILevelFormatter *textFormatter;
    OAOutlineEntry *topEntry;

    DSTART;
    [super windowDidLoad];
    //[levelsOutlineView setBackgroundColor:[NSColor redColor]];
    [levelsOutlineView setHierarchical:NO];
    [levelsOutlineView setEditable:YES];

    //textFormatter = [[OAOutlineTextFormatter alloc] init];
    textFormatter = [[FILevelFormatter alloc] init];
    [textFormatter setValueSelector:@selector (displayName:)];
    [levelsOutlineView setFormatter:textFormatter];
    [textFormatter release];

    topEntry = [[OAOutlineEntry alloc] initInView:levelsOutlineView];
    [levelsOutlineView setTopLevelEntry:topEntry];
    [topEntry release];
    DEND;
}

//----------------------------------------------------------------------

- (BOOL) canInspectObject:anObject
{
    DSTART;
    DEND;
    return anObject != nil && [anObject isKindOfClass:[FIWindowController class]];
}

//----------------------------------------------------------------------

- (void) updateInspector
{
    FIWindowController *windowController;
    OAOutlineEntry *topEntry, *levelEntry;
    FILevelFormatter *formatter;

    FIDock *dock;
    NSArray *levels;
    NSEnumerator *levelEnumerator;
    FILevel *level;

    DSTART;
    windowController = (FIWindowController *)[self inspectedObject];
    dock = [[windowController document] model];
    levels = [dock levels];

    //formatter = [[FILevelFormatter alloc] init];
    //[levelsOutlineView setFormatter:formatter];
    //[formatter release];

    topEntry = [levelsOutlineView topLevelEntry];

    levelEnumerator = [levels objectEnumerator];
    while (level = [levelEnumerator nextObject])
    {
        levelEntry = [[OAOutlineEntry alloc] initWithRepresentedObject:level inEntry:topEntry];
        [topEntry appendEntry:levelEntry];
        [levelEntry release];
    }

    //SNLog (topEntry);

    DEND;
}

//----------------------------------------------------------------------

- (void) toggleOption:sender
{
}

@end
