#import "Fiend.h"

RCS_ID ("$Id$");

#import "FIInspectorManager.h"

#import "FITileInspector.h"
#import "FIDockInspector.h"

@implementation FIInspectorManager

+ sharedInspectorManager
{
    static FIInspectorManager *instance = nil;

    if (instance == nil)
    {
        instance = [[FIInspectorManager alloc] init];
        [instance setWindowFrameAutosaveName:@"Inspector"];
    }

    return instance;
}

//----------------------------------------------------------------------

#define MODE_GENERAL @"General"

- init
{
    if ([super initWithWindowNibName:@"FIInspector"] == nil)
        return nil;

    [self addInspector:[[[FITileInspector alloc] init] autorelease] toMode:MODE_GENERAL];
    //[self addInspector:[[[FIDockInspector alloc] init] autorelease] toMode:MODE_GENERAL];
    [self setMode:MODE_GENERAL];

    undoManager = nil;

    return self;
}

//----------------------------------------------------------------------

- (void) dealloc
{
    SNRelease (undoManager);
    [super dealloc];
}

//----------------------------------------------------------------------

- (NSUndoManager *) undoManager
{
    return undoManager;
}

//----------------------------------------------------------------------

- (void) setUndoManager:(NSUndoManager *)newUndoManager
{
    if (newUndoManager == undoManager)
        return;

    SNRelease (undoManager);
    undoManager = [newUndoManager retain];
}

//======================================================================
// NSWindow delegate
//======================================================================

- (void) windowDidBecomeKey:(NSNotification *)aNotification
{
    [[OFUserDefaults sharedUserDefaults] setBool:YES forKey:DK_ShowInspectorPanel];
}

//----------------------------------------------------------------------

- (void) windowWillClose:(NSNotification *)aNotification
{
    [[OFUserDefaults sharedUserDefaults] setBool:NO forKey:DK_ShowInspectorPanel];
}

//----------------------------------------------------------------------

- (NSUndoManager *) windowWillReturnUndoManager:(NSWindow *)window
{
    return undoManager;
}

@end
