//
// $Id$
//

#import <AppKit/AppKit.h>

#import "SNInspector.h"

@interface FITileInspector : SNInspector
{
    IBOutlet NSImageView *imageView;
    IBOutlet NSTextField *nameField;
    IBOutlet NSTextField *pathField;

    IBOutlet NSButtonCell *autolaunchCell;
    IBOutlet NSButtonCell *animateCell;
    IBOutlet NSButtonCell *persistCell;

    IBOutlet NSTextField *autoLaunchValueField;
    IBOutlet NSPopUpButton *autoLaunchUnitsPopUp;
}

+ sharedTileInspector;

- init;
- (void) dealloc;

- (void) windowDidLoad;

- (BOOL) canInspectObject:anObject;
- (void) updateInspector;
- (void) endEditing;
- (void) abortEditing;

- (void) toggleOption:sender;

- (void) willChangeInspectedObject;
- (void) didChangeInspectedObject;

- (void) applicationDidChange:(NSNotification *)aNotification;

- (TimeInterval) autoLaunchDelay;
- (void) setAutoLaunchDelay:(TimeInterval)newDelay;

- (void) changeDelayValue:sender;
- (void) changeDelayUnits:sender;

@end
