//
// $Id$
//

#import <AppKit/AppKit.h>

@class SNInspectorManager;

@interface SNInspector : NSWindowController
{
    SNInspectorManager *nonretainedInspectorManager; // Remove now that we have changed inspector window?

    IBOutlet NSView *inspectorView;

    id inspectedObject;
}

- initWithWindowNibName:(NSString *)windowNibName;
- (void) dealloc;

- (SNInspectorManager *) inspectorManager;
- (void) setInspectorManager:(SNInspectorManager *)newInspectorManager;

- inspectedObject;
- (void) setInspectedObject:newObject;

- (NSView *) inspectorView;
- (NSWindow *) inspectorWindow;

- (void) loadInspector;
- (void) windowDidLoad;

//----------------------------------------------------------------------
// Subclass responsabilities
//----------------------------------------------------------------------

- (BOOL) canInspectObject:anObject;
- (void) updateInspector;
- (void) endEditing;
- (void) abortEditing;

// Called from inspector manager
- (void) willShowInspector;
- (void) willHideInspector;

// Called internally.
- (void) willChangeInspectedObject;
- (void) didChangeInspectedObject;

//----------------------------------------------------------------------
// Debugging
//----------------------------------------------------------------------

- (NSMutableDictionary *) debugDictionary;

@end
