//
// $Id$
//

#import <AppKit/AppKit.h>

@class SNInspector;

@interface SNInspectorManager : NSWindowController
{
    IBOutlet NSView *noInspectorView;
    NSPoint inspectorViewOrigin;

    id mode;
    NSMutableDictionary *inspectorsByMode;

    SNInspector *currentInspector;
    id inspectedObject;
}

- initWithWindowNibName:(NSString *)windowNibName;
- (void) dealloc;

- (void) windowDidLoad;

- (void) addInspector:(SNInspector *)anInspector toMode:aMode;
- (NSArray *) inspectorsForMode:aMode;

- mode;
- (void) setMode:newMode;

- (SNInspector *) currentInspector;
- (void) setCurrentInspector:(SNInspector *)newInspector;
- (void) updateCurrentInspector;

- inspectedObject;
- (void) setInspectedObject:newObject;

//----------------------------------------------------------------------
// NSWindow delegate
//----------------------------------------------------------------------

- (void) windowWillClose:(NSNotification *)aNotification;

//----------------------------------------------------------------------
// Other
//----------------------------------------------------------------------

- (NSMutableDictionary *) debugDictionary;
//- (NSString *) description;

@end
