#import "Fiend.h"

RCS_ID ("$Id$");

#import "FILevelFormatter.h"

#import "FILevel.h"

@implementation FILevelFormatter

- init
{
    if ([super init] == nil)
        return nil;

    textCell = [[NSTextFieldCell allocWithZone:[self zone]] initTextCell:@"foobar"];

    return self;
}

//----------------------------------------------------------------------

- (void) dealloc
{
    SNRelease (textCell);
    [super dealloc];
}

//----------------------------------------------------------------------

- (float) entryHeight:(OAOutlineEntry *)anEntry
{
    FILevel *level;
    float height;

    level = [anEntry representedObject];
    if (level == nil)
    {
        height = [super entryHeight:anEntry];
    }
    else
    {
        NSSize cellSize;
        NSString *displayName;

        displayName = [level displayName];
        OBPOSTCONDITION (displayName != nil);
        [textCell setStringValue:[level displayName]];
        cellSize = [textCell cellSize];
        height = cellSize.height;
    }

    return height;
}

//----------------------------------------------------------------------

- (void)drawEntry:(OAOutlineEntry *)anEntry entryRect:(NSRect)rect selected:(BOOL)selected
           parent:(BOOL)parent hidden:(BOOL)hidden dragging:(BOOL)dragging
{
    FILevel *level;
    
    level = [anEntry representedObject];
    OBPOSTCONDITION (level != nil);
    [textCell setStringValue:[level displayName]];
    
    //SNLog (anEntry);
    DSTART;
    SNLogRect (rect);
    //SNLogBool (selected);
    //SNLogBool (parent);
    //SNLogBool (hidden);
    //SNLogBool (dragging);
    [super drawEntry:anEntry entryRect:rect selected:selected parent:parent hidden:hidden dragging:dragging];
    [textCell drawWithFrame:rect inView:[anEntry outlineView]];
}

//----------------------------------------------------------------------

- (void) drawSelectionForEntry:(OAOutlineEntry *)anEntry entryRect:(NSRect)rect
{
    //[[NSColor blueColor] set];
    //[[NSColor lightGrayColor] set];
    [[NSColor whiteColor] set];
    NSRectFill (rect);
}

@end
