//
// $Id$
//

#import <AppKit/AppKit.h>
#import "FIModelComponent.h"
#import "FiendTypes.h"

@class FILevel;

extern NSString *FIApplicationLocationDidChangeNotification;
extern NSString *FIApplicationDidChangeNotification;

@interface FIApplication : FIModelComponent <NSCoding>
{
    FILevel *nonretainedLevel; // Be sure that this will work with undocked tiles...

    NSString *path;
    DockLocation location;

    BOOL shouldAutoLaunch;
    BOOL shouldAnimate;
    BOOL isPersistent;

    TimeInterval autoLaunchDelay;
}

- initWithRepresentedPath:(NSString *)aPath;
- (void) dealloc;

//======================================================================
//" NSCoding
//======================================================================

- (void) encodeWithCoder:(NSCoder *)aCoder;
- initWithCoder:(NSCoder *)aDecoder;

//======================================================================
//" Loading and saving
//======================================================================

+ (FIApplication *) applicationFromPropertyList:(NSDictionary *)propertyList;
- (NSDictionary *) propertyListForApplication;

//======================================================================
//" Controlling general attributes
//======================================================================

- (NSString *) path;
- (NSString *) shortName;

- (FILevel *) level;
- (void) setLevel:(FILevel *)newLevel;

- (BOOL) shouldAutoLaunch;
- (void) setShouldAutoLaunch:(BOOL)flag;

- (BOOL) shouldAnimate;
- (void) setShouldAnimate:(BOOL)flag;

- (BOOL) isPersistent;
- (void) setIsPersistent:(BOOL)flag;

- (TimeInterval) autoLaunchDelay;
- (void) setAutoLaunchDelay:(TimeInterval)newDelay;

//======================================================================
//" Controlling location
//======================================================================

- (DockLocation) location;
- (void) setLocation:(DockLocation)newLocation;

- (void) rotateLocationClockwise:(BOOL)clockwise;

//======================================================================
//" Debugging
//======================================================================

- (NSMutableDictionary *) debugDictionary;

//======================================================================
//" Other
//======================================================================

@end
