#import "Fiend.h"

RCS_ID ("$Id$");

#import "FIColorPreferences.h"

@implementation FIColorPreferences

- (void) updateUI
{
    [selectedTileColorWell setColor:[defaults colorForKey:DK_SelectedTileColor]];
    [flagCueColorWell setColor:[defaults colorForKey:DK_FlagCueColor]];
    [flagCueBorderColorWell setColor:[defaults colorForKey:DK_FlagCueBorderColor]];
}

//----------------------------------------------------------------------

- (void) restoreDefaultsNoPrompt
{
    [super restoreDefaultsNoPrompt];

    [[NSNotificationCenter defaultCenter] postNotificationName:FIPreferencesSelectedTileColorDidChangeNotification object:nil];

    // A bit more cheating, since I know both notifications do the same thing to the tile view.
    // XXX: Maybe there should just be one notification for tile view style...
    //[[NSNotificationCenter defaultCenter] postNotificationName:FIPreferencesFlagCueColorDidChangeNotification object:nil];
}

//----------------------------------------------------------------------

- (void) changeColor:sender
{
    NSColor *color;
    
    color = [sender color];
    if (sender == selectedTileColorWell)
    {
        [defaults setColor:color forKey:DK_SelectedTileColor];
        [[NSNotificationCenter defaultCenter] postNotificationName:FIPreferencesSelectedTileColorDidChangeNotification object:nil];
    }
    else if (sender == flagCueColorWell)
    {
        [defaults setColor:color forKey:DK_FlagCueColor];
        [[NSNotificationCenter defaultCenter] postNotificationName:FIPreferencesFlagCueColorDidChangeNotification object:nil];
    }
    else if (sender == flagCueBorderColorWell)
    {
        [defaults setColor:color forKey:DK_FlagCueBorderColor];
        // I'm going to be lazy, and use the same notification.
        [[NSNotificationCenter defaultCenter] postNotificationName:FIPreferencesFlagCueColorDidChangeNotification object:nil];
    }
}

@end
