#import "Fiend.h"

RCS_ID ("$Id$");

#import "FIGeneralPreferences.h"

@implementation FIGeneralPreferences

- (void) updateUI
{
    // XXX: Wouldn't [self defaults] be better?
    [[optionsMatrix cellWithTag:0] setState:[defaults boolForKey:DK_UseSounds]];
    [[optionsMatrix cellWithTag:1] setState:[defaults boolForKey:DK_StrictCopy]];
    [[optionsMatrix cellWithTag:2] setState:[defaults boolForKey:DK_HideTiles]];
    [[optionsMatrix cellWithTag:3] setState:[defaults boolForKey:DK_ShowLevelNumber]];
    [[optionsMatrix cellWithTag:4] setState:[defaults boolForKey:DK_ClosePostLaunch]];
    [[optionsMatrix cellWithTag:5] setState:[defaults boolForKey:DK_EnableSingleClick]];
    [[optionsMatrix cellWithTag:6] setState:[defaults boolForKey:DK_ShowFlagCues]];
}

//----------------------------------------------------------------------

- (void) restoreDefaultsNoPrompt
{
    NSNotificationCenter *defaultCenter;
    
    [super restoreDefaultsNoPrompt];

    defaultCenter = [NSNotificationCenter defaultCenter];
    
    [defaultCenter postNotificationName:FIPreferencesHideTilesDidChangeNotification object:nil];
    [defaultCenter postNotificationName:FIPreferencesShowLevelNumberDidChangeNotification object:nil];
    [defaultCenter postNotificationName:FIPreferencesShowFlagCuesDidChangeNotification object:nil];
}

//----------------------------------------------------------------------

- (void) toggleOption:sender
{
    NSCell *selectedCell;
    int tag, state;

    selectedCell = [sender selectedCell];
    tag = [selectedCell tag];
    state = [selectedCell state];
    switch (tag)
    {
      case 0:
          [defaults setBool:state forKey:DK_UseSounds];
          break;

      case 1:
          [defaults setBool:state forKey:DK_StrictCopy];
          break;

      case 2:
          [defaults setBool:state forKey:DK_HideTiles];
          [[NSNotificationCenter defaultCenter] postNotificationName:FIPreferencesHideTilesDidChangeNotification object:nil];
          break;

      case 3:
          [defaults setBool:state forKey:DK_ShowLevelNumber];
          [[NSNotificationCenter defaultCenter] postNotificationName:FIPreferencesShowLevelNumberDidChangeNotification object:nil];
          break;

      case 4:
          [defaults setBool:state forKey:DK_ClosePostLaunch];
          break;

      case 5:
          [defaults setBool:state forKey:DK_EnableSingleClick];
          break;

      case 6:
          [defaults setBool:state forKey:DK_ShowFlagCues];
          [[NSNotificationCenter defaultCenter] postNotificationName:FIPreferencesShowFlagCuesDidChangeNotification object:nil];
          break;

      default:
          // Do nothing.
          break;
    }

    [self valuesHaveChanged];
}

@end
